package com.example.damien.whichfingers;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.os.StrictMode;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.ImageButton;
import android.widget.Switch;

import java.util.LinkedList;

public class MainActivity extends AppCompatActivity {
    private TouchCanvas _tCanvas = null;
    private Thread hidThread;

    LinkedList<String> msgs_send = new LinkedList<String>();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
        StrictMode.setThreadPolicy(policy);

        setContentView(R.layout.activity_main);

        final WhichFingersHID wf = new WhichFingersHID(getApplicationContext());

        final BroadcastReceiver receiver = new BroadcastReceiver() {
            public void onReceive(Context context, Intent intent) {
                if (hidThread != null) {
                    hidThread.interrupt();
                }
                hidThread = new Thread() {
                    @Override
                    public void run() {
                        wf.initializeCommunication();
                        wf.run();
                    }
                };
                hidThread.start();
            }
        };

        wf.connectToDevice(receiver);

        ImageButton button= (ImageButton) findViewById(R.id.menu);
        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Switch sym = (Switch) findViewById(R.id.sym180);
                Button resetButton = (Button) findViewById(R.id.resetButton);
                if (sym.isShown()) {
                    sym.setVisibility(Switch.INVISIBLE);
                    resetButton.setVisibility(Button.INVISIBLE);
                } else {
                    sym.setVisibility(Switch.VISIBLE);
                    resetButton.setVisibility(Button.VISIBLE);
                }
            }
        });

        Button resetButton = (Button) findViewById(R.id.resetButton);
        resetButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                wf.connectToDevice(receiver);
                _tCanvas.reset();
            }
        });

        Switch sym = (Switch) findViewById(R.id.sym180);
        sym.setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {
            public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
                if (_tCanvas != null) {
                    _tCanvas.setSym(isChecked);
                }
            }
        });

        _tCanvas = new TouchCanvas(this, wf);
        _tCanvas.setList(msgs_send);
    }
}
