package com.example.damien.whichfingers;

import android.app.Activity;
import android.view.MotionEvent;
import android.view.View;
import android.widget.RelativeLayout;

import java.util.LinkedList;

public class TouchCanvas {

    private DrawingView[] _tab = new DrawingView[20];
    private int[] _fid = new int[] {5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5}; // all unknown
    private Activity _activity;
    private FingerTouchAssociationTask fingerTouchAssociationTask;

    public TouchCanvas(Activity activity, WhichFingersHID wf) {
        _activity = activity;
        fingerTouchAssociationTask = new FingerTouchAssociationTask(wf, _tab);

        RelativeLayout finger_layout = (RelativeLayout)_activity.findViewById(R.id.touchesLayout);
        for (int k = 0; k < 10; k++) {
            _tab[k] = new DrawingView(_activity.getApplicationContext());
            activity.addContentView(_tab[k], finger_layout.getLayoutParams());
            _tab[k].setVisibility(View.INVISIBLE);
        }

        finger_layout.setOnTouchListener(
                new RelativeLayout.OnTouchListener() {
                    public boolean onTouch(View v, MotionEvent m) {
                        handleTouch(m);
                        return true;
                    }
                }
        );
    }

    LinkedList<String> msgs_send = null;
    public void setList(LinkedList<String> list) { msgs_send = list; }

    public void setSym(boolean val) {
        for (int k = 0; k < _tab.length; k++) {
            if (_tab[k] != null) {
                _tab[k].setSym(val);
            }
        }
    }

    public void handleTouch(MotionEvent m) {

        for (int k = 0; k < m.getPointerCount(); k++) {
            int x = (int) m.getX(k);
            int y = (int) m.getY(k);
            int id = m.getPointerId(k);
            int action = m.getActionMasked();
            boolean isActionIndex = (k == m.getActionIndex());

            _tab[id].setVisibility(View.VISIBLE);
            _tab[id].setAlpha(1.0f);
            _tab[id].setPosition(x,y);

            if (isActionIndex) {
                if (action == MotionEvent.ACTION_DOWN || action == MotionEvent.ACTION_POINTER_DOWN) {
                    _tab[id].animate().cancel();
                    _tab[id].setFid(5);
                    _tab[id].setDown(true);
                    fingerTouchAssociationTask.addTouch(new Touch(id, x, y));
                } else if (action == MotionEvent.ACTION_UP || action == MotionEvent.ACTION_POINTER_UP) {
                    _tab[id].animate().cancel();
                    _tab[id].animate().alpha(0.0f);
                    _tab[id].setDown(false);
                    fingerTouchAssociationTask.removeTouch(id);
                    _fid[id] = 5;
                }
            }
        }

    }


    public void reset() {
        fingerTouchAssociationTask.reset();
        for (DrawingView v : _tab) {
            if(v != null) v.reset();
        }
    }
}
